module SyncMultWrapX (areset, clk, a, b, prod);
  
  parameter kinsize=16;
  input clk, areset;
  input [kinsize-1:0] a, b;
  output [kinsize*2-1:0] prod;
  
  reg [kinsize-1:0] a_ms, a_db_sync;
  reg [kinsize-1:0] b_ms, b_db_sync;
  //reg [15:0] pi, pj;
  
  //assign prod = pj;
  
  always @(posedge clk or posedge areset)
  begin
    if (areset)
      begin
        a_ms <= 0;
        b_ms <= 0;
        a_db_sync <= 0;
        b_db_sync <= 0;
      end
    else
      begin
        a_ms <= a;
        b_ms <= b;
        a_db_sync <= a_ms;
        b_db_sync <= b_ms;
      end
  end
  
  MultCoreX MultIPCoreX(
    .a (a_db_sync),
    .b (b_db_sync),
    .sclr (areset),
    .clk (clk),
    .p (prod));

endmodule